#!/usr/bin/env sh

CURRENT_DIR=$(pwd)
SCRIPT_DIR=$(dirname "$0")
ABSOLUTE_PATH="$CURRENT_DIR/$SCRIPT_DIR"
TEMPLATE_PATH="$ABSOLUTE_PATH/../template/.twistcli.yaml.tmpl"
mkdir -p "$ABSOLUTE_PATH/../generated"
DEST_PATH="$ABSOLUTE_PATH/../generated/.twistcli.yaml"

replace_values() {
  if [ -z "$TWIST_CLI_U" ]; then
    echo "TWIST_CLI_U is empty"
    exit 1
  elif [ -z "$TWIST_CLI_P" ]; then
    echo "TWIST_CLI_P is empty"
    exit 1
  elif [ -z "$TWIST_CLI_H" ]; then
    echo "TWIST_CLI_H is empty"
    exit 1
  elif [ -z "$DEFAULT_BUILD_STEPS" ]; then
    echo "DEFAULT_BUILD_STEPS is empty"
    exit 1
  fi

  sed -e "s;_TWIST_CLI_U_;${TWIST_CLI_U};" \
  -e "s;_TWIST_CLI_P_;${TWIST_CLI_P};" \
  -e "s;_TWIST_CLI_H_;${TWIST_CLI_H};" \
  -e "s;_DEFAULT_BUILD_STEPS_;${DEFAULT_BUILD_STEPS};" \
  "$TEMPLATE_PATH" > "$DEST_PATH"
}

validate_template_file_path() {
  if [ -f "$1" ]; then
    echo "$1 Exists!"
    return
  else
    echo "Validation failed, the file $1 does not exist."
    exit 1
  fi
}

validate_template_file_path "$TEMPLATE_PATH"
replace_values
validate_template_file_path "$DEST_PATH"